diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/demosaic/misc_demosaic.cpp libkdcraw/libkdcraw/libraw/src/demosaic/misc_demosaic.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/demosaic/misc_demosaic.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/demosaic/misc_demosaic.cpp	2022-11-07 07:46:31.734795008 +0300
@@ -0,0 +1,423 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw uses code from dcraw.c -- Dave Coffin's raw photo decoder,
+ dcraw.c is copyright 1997-2018 by Dave Coffin, dcoffin a cybercom o net.
+ LibRaw do not use RESTRICTED code from dcraw.c
+
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/dcraw_defs.h"
+
+void LibRaw::pre_interpolate()
+{
+  ushort(*img)[4];
+  int row, col, c;
+  RUN_CALLBACK(LIBRAW_PROGRESS_PRE_INTERPOLATE, 0, 2);
+  if (shrink)
+  {
+    if (half_size)
+    {
+      height = iheight;
+      width = iwidth;
+      if (filters == 9)
+      {
+        for (row = 0; row < 3; row++)
+          for (col = 1; col < 4; col++)
+            if (!(image[row * width + col][0] | image[row * width + col][2]))
+              goto break2;
+      break2:
+        for (; row < height; row += 3)
+          for (col = (col - 1) % 3 + 1; col < width - 1; col += 3)
+          {
+            img = image + row * width + col;
+            for (c = 0; c < 3; c += 2)
+              img[0][c] = (img[-1][c] + img[1][c]) >> 1;
+          }
+      }
+    }
+    else
+    {
+      img = (ushort(*)[4])calloc(height, width * sizeof *img);
+      merror(img, "pre_interpolate()");
+      for (row = 0; row < height; row++)
+        for (col = 0; col < width; col++)
+        {
+          c = fcol(row, col);
+          img[row * width + col][c] =
+              image[(row >> 1) * iwidth + (col >> 1)][c];
+        }
+      free(image);
+      image = img;
+      shrink = 0;
+    }
+  }
+  if (filters > 1000 && colors == 3)
+  {
+    mix_green = four_color_rgb ^ half_size;
+    if (four_color_rgb | half_size)
+      colors++;
+    else
+    {
+      for (row = FC(1, 0) >> 1; row < height; row += 2)
+        for (col = FC(row, 1) & 1; col < width; col += 2)
+          image[row * width + col][1] = image[row * width + col][3];
+      filters &= ~((filters & 0x55555555U) << 1);
+    }
+  }
+  if (half_size)
+    filters = 0;
+  RUN_CALLBACK(LIBRAW_PROGRESS_PRE_INTERPOLATE, 1, 2);
+}
+
+void LibRaw::border_interpolate(int border)
+{
+  unsigned row, col, y, x, f, c, sum[8];
+
+  for (row = 0; row < height; row++)
+    for (col = 0; col < width; col++)
+    {
+      if (col == (unsigned)border && row >= (unsigned)border && row < (unsigned)(height - border))
+        col = width - border;
+      memset(sum, 0, sizeof sum);
+      for (y = row - 1; y != row + 2; y++)
+        for (x = col - 1; x != col + 2; x++)
+          if (y < height && x < width)
+          {
+            f = fcol(y, x);
+            sum[f] += image[y * width + x][f];
+            sum[f + 4]++;
+          }
+      f = fcol(row, col);
+      FORC(unsigned(colors)) if (c != f && sum[c + 4]) image[row * width + col][c] =
+          sum[c] / sum[c + 4];
+    }
+}
+
+void LibRaw::lin_interpolate_loop(int *code, int size)
+{
+  int row;
+  for (row = 1; row < height - 1; row++)
+  {
+    int col, *ip;
+    ushort *pix;
+    for (col = 1; col < width - 1; col++)
+    {
+      int i;
+      int sum[4];
+      pix = image[row * width + col];
+      ip = code + ((((row % size) * 16) + (col % size)) * 32);
+      memset(sum, 0, sizeof sum);
+      for (i = *ip++; i--; ip += 3)
+        sum[ip[2]] += pix[ip[0]] << ip[1];
+      for (i = colors; --i; ip += 2)
+        pix[ip[0]] = sum[ip[0]] * ip[1] >> 8;
+    }
+  }
+}
+
+void LibRaw::lin_interpolate()
+{
+  std::vector<int> code_buffer(16 * 16 * 32);
+  int* code = &code_buffer[0], size = 16, *ip, sum[4];
+  int f, c, x, y, row, col, shift, color;
+
+  RUN_CALLBACK(LIBRAW_PROGRESS_INTERPOLATE, 0, 3);
+
+  if (filters == 9)
+    size = 6;
+  border_interpolate(1);
+  for (row = 0; row < size; row++)
+    for (col = 0; col < size; col++)
+    {
+      ip = code + (((row * 16) + col) * 32) + 1;
+      f = fcol(row, col);
+      memset(sum, 0, sizeof sum);
+      for (y = -1; y <= 1; y++)
+        for (x = -1; x <= 1; x++)
+        {
+          shift = (y == 0) + (x == 0);
+          color = fcol(row + y + 48, col + x + 48);
+          if (color == f)
+            continue;
+          *ip++ = (width * y + x) * 4 + color;
+          *ip++ = shift;
+          *ip++ = color;
+          sum[color] += 1 << shift;
+        }
+      code[(row * 16 + col) * 32] = (ip - (code + ((row * 16) + col) * 32)) / 3;
+      FORCC
+      if (c != f)
+      {
+        *ip++ = c;
+        *ip++ = sum[c] > 0 ? 256 / sum[c] : 0;
+      }
+    }
+  RUN_CALLBACK(LIBRAW_PROGRESS_INTERPOLATE, 1, 3);
+  lin_interpolate_loop(code, size);
+  RUN_CALLBACK(LIBRAW_PROGRESS_INTERPOLATE, 2, 3);
+}
+
+/*
+   This algorithm is officially called:
+
+   "Interpolation using a Threshold-based variable number of gradients"
+
+   described in
+   http://scien.stanford.edu/pages/labsite/1999/psych221/projects/99/tingchen/algodep/vargra.html
+
+   I've extended the basic idea to work with non-Bayer filter arrays.
+   Gradients are numbered clockwise from NW=0 to W=7.
+ */
+void LibRaw::vng_interpolate()
+{
+  static const signed char *cp,
+      terms[] =
+          {-2, -2, +0,   -1, 0,  0x01, -2, -2, +0,   +0, 1,  0x01, -2, -1, -1,
+           +0, 0,  0x01, -2, -1, +0,   -1, 0,  0x02, -2, -1, +0,   +0, 0,  0x03,
+           -2, -1, +0,   +1, 1,  0x01, -2, +0, +0,   -1, 0,  0x06, -2, +0, +0,
+           +0, 1,  0x02, -2, +0, +0,   +1, 0,  0x03, -2, +1, -1,   +0, 0,  0x04,
+           -2, +1, +0,   -1, 1,  0x04, -2, +1, +0,   +0, 0,  0x06, -2, +1, +0,
+           +1, 0,  0x02, -2, +2, +0,   +0, 1,  0x04, -2, +2, +0,   +1, 0,  0x04,
+           -1, -2, -1,   +0, 0,  -128, -1, -2, +0,   -1, 0,  0x01, -1, -2, +1,
+           -1, 0,  0x01, -1, -2, +1,   +0, 1,  0x01, -1, -1, -1,   +1, 0,  -120,
+           -1, -1, +1,   -2, 0,  0x40, -1, -1, +1,   -1, 0,  0x22, -1, -1, +1,
+           +0, 0,  0x33, -1, -1, +1,   +1, 1,  0x11, -1, +0, -1,   +2, 0,  0x08,
+           -1, +0, +0,   -1, 0,  0x44, -1, +0, +0,   +1, 0,  0x11, -1, +0, +1,
+           -2, 1,  0x40, -1, +0, +1,   -1, 0,  0x66, -1, +0, +1,   +0, 1,  0x22,
+           -1, +0, +1,   +1, 0,  0x33, -1, +0, +1,   +2, 1,  0x10, -1, +1, +1,
+           -1, 1,  0x44, -1, +1, +1,   +0, 0,  0x66, -1, +1, +1,   +1, 0,  0x22,
+           -1, +1, +1,   +2, 0,  0x10, -1, +2, +0,   +1, 0,  0x04, -1, +2, +1,
+           +0, 1,  0x04, -1, +2, +1,   +1, 0,  0x04, +0, -2, +0,   +0, 1,  -128,
+           +0, -1, +0,   +1, 1,  -120, +0, -1, +1,   -2, 0,  0x40, +0, -1, +1,
+           +0, 0,  0x11, +0, -1, +2,   -2, 0,  0x40, +0, -1, +2,   -1, 0,  0x20,
+           +0, -1, +2,   +0, 0,  0x30, +0, -1, +2,   +1, 1,  0x10, +0, +0, +0,
+           +2, 1,  0x08, +0, +0, +2,   -2, 1,  0x40, +0, +0, +2,   -1, 0,  0x60,
+           +0, +0, +2,   +0, 1,  0x20, +0, +0, +2,   +1, 0,  0x30, +0, +0, +2,
+           +2, 1,  0x10, +0, +1, +1,   +0, 0,  0x44, +0, +1, +1,   +2, 0,  0x10,
+           +0, +1, +2,   -1, 1,  0x40, +0, +1, +2,   +0, 0,  0x60, +0, +1, +2,
+           +1, 0,  0x20, +0, +1, +2,   +2, 0,  0x10, +1, -2, +1,   +0, 0,  -128,
+           +1, -1, +1,   +1, 0,  -120, +1, +0, +1,   +2, 0,  0x08, +1, +0, +2,
+           -1, 0,  0x40, +1, +0, +2,   +1, 0,  0x10},
+      chood[] = {-1, -1, -1, 0, -1, +1, 0, +1, +1, +1, +1, 0, +1, -1, 0, -1};
+  ushort(*brow[5])[4], *pix;
+  int prow = 8, pcol = 2, *ip, *code[16][16], gval[8], gmin, gmax, sum[4];
+  int row, col, x, y, x1, x2, y1, y2, t, weight, grads, color, diag;
+  int g, diff, thold, num, c;
+
+  lin_interpolate();
+
+  if (filters == 1)
+    prow = pcol = 16;
+  if (filters == 9)
+    prow = pcol = 6;
+  ip = (int *)calloc(prow * pcol, 1280);
+  merror(ip, "vng_interpolate()");
+  for (row = 0; row < prow; row++) /* Precalculate for VNG */
+    for (col = 0; col < pcol; col++)
+    {
+      code[row][col] = ip;
+      for (cp = terms, t = 0; t < 64; t++)
+      {
+        y1 = *cp++;
+        x1 = *cp++;
+        y2 = *cp++;
+        x2 = *cp++;
+        weight = *cp++;
+        grads = *cp++;
+        color = fcol(row + y1 + 144, col + x1 + 144);
+        if (fcol(row + y2 + 144, col + x2 + 144) != color)
+          continue;
+        diag = (fcol(row, col + 1) == color && fcol(row + 1, col) == color) ? 2
+                                                                            : 1;
+        if (abs(y1 - y2) == diag && abs(x1 - x2) == diag)
+          continue;
+        *ip++ = (y1 * width + x1) * 4 + color;
+        *ip++ = (y2 * width + x2) * 4 + color;
+        *ip++ = weight;
+        for (g = 0; g < 8; g++)
+          if (grads & 1 << g)
+            *ip++ = g;
+        *ip++ = -1;
+      }
+      *ip++ = INT_MAX;
+      for (cp = chood, g = 0; g < 8; g++)
+      {
+        y = *cp++;
+        x = *cp++;
+        *ip++ = (y * width + x) * 4;
+        color = fcol(row, col);
+        if (fcol(row + y + 144, col + x + 144) != color &&
+            fcol(row + y * 2 + 144, col + x * 2 + 144) == color)
+          *ip++ = (y * width + x) * 8 + color;
+        else
+          *ip++ = 0;
+      }
+    }
+  brow[4] = (ushort(*)[4])calloc(width * 3, sizeof **brow);
+  merror(brow[4], "vng_interpolate()");
+  for (row = 0; row < 3; row++)
+    brow[row] = brow[4] + row * width;
+  for (row = 2; row < height - 2; row++)
+  { /* Do VNG interpolation */
+    if (!((row - 2) % 256))
+      RUN_CALLBACK(LIBRAW_PROGRESS_INTERPOLATE, (row - 2) / 256 + 1,
+                   ((height - 3) / 256) + 1);
+    for (col = 2; col < width - 2; col++)
+    {
+      pix = image[row * width + col];
+      ip = code[row % prow][col % pcol];
+      memset(gval, 0, sizeof gval);
+      while ((g = ip[0]) != INT_MAX)
+      { /* Calculate gradients */
+        diff = ABS(pix[g] - pix[ip[1]]) << ip[2];
+        gval[ip[3]] += diff;
+        ip += 5;
+        if ((g = ip[-1]) == -1)
+          continue;
+        gval[g] += diff;
+        while ((g = *ip++) != -1)
+          gval[g] += diff;
+      }
+      ip++;
+      gmin = gmax = gval[0]; /* Choose a threshold */
+      for (g = 1; g < 8; g++)
+      {
+        if (gmin > gval[g])
+          gmin = gval[g];
+        if (gmax < gval[g])
+          gmax = gval[g];
+      }
+      if (gmax == 0)
+      {
+        memcpy(brow[2][col], pix, sizeof *image);
+        continue;
+      }
+      thold = gmin + (gmax >> 1);
+      memset(sum, 0, sizeof sum);
+      color = fcol(row, col);
+      for (num = g = 0; g < 8; g++, ip += 2)
+      { /* Average the neighbors */
+        if (gval[g] <= thold)
+        {
+          FORCC
+          if (c == color && ip[1])
+            sum[c] += (pix[c] + pix[ip[1]]) >> 1;
+          else
+            sum[c] += pix[ip[0] + c];
+          num++;
+        }
+      }
+      FORCC
+      { /* Save to buffer */
+        t = pix[color];
+        if (c != color)
+          t += (sum[c] - sum[color]) / num;
+        brow[2][col][c] = CLIP(t);
+      }
+    }
+    if (row > 3) /* Write buffer to image */
+      memcpy(image[(row - 2) * width + 2], brow[0] + 2,
+             (width - 4) * sizeof *image);
+    for (g = 0; g < 4; g++)
+      brow[(g - 1) & 3] = brow[g];
+  }
+  memcpy(image[(row - 2) * width + 2], brow[0] + 2,
+         (width - 4) * sizeof *image);
+  memcpy(image[(row - 1) * width + 2], brow[1] + 2,
+         (width - 4) * sizeof *image);
+  free(brow[4]);
+  free(code[0][0]);
+}
+
+/*
+   Patterned Pixel Grouping Interpolation by Alain Desbiolles
+*/
+void LibRaw::ppg_interpolate()
+{
+  int dir[5] = {1, width, -1, -width, 1};
+  int row, col, diff[2], guess[2], c, d, i;
+  ushort(*pix)[4];
+
+  border_interpolate(3);
+
+  /*  Fill in the green layer with gradients and pattern recognition: */
+  RUN_CALLBACK(LIBRAW_PROGRESS_INTERPOLATE, 0, 3);
+#ifdef LIBRAW_USE_OPENMP
+#pragma omp parallel for default(shared) private(guess, diff, row, col, d, c,  \
+                                                 i, pix) schedule(static)
+#endif
+  for (row = 3; row < height - 3; row++)
+    for (col = 3 + (FC(row, 3) & 1), c = FC(row, col); col < width - 3;
+         col += 2)
+    {
+      pix = image + row * width + col;
+      for (i = 0; i < 2; i++)
+      {
+        d = dir[i];
+        guess[i] = (pix[-d][1] + pix[0][c] + pix[d][1]) * 2 - pix[-2 * d][c] -
+                   pix[2 * d][c];
+        diff[i] =
+            (ABS(pix[-2 * d][c] - pix[0][c]) + ABS(pix[2 * d][c] - pix[0][c]) +
+             ABS(pix[-d][1] - pix[d][1])) *
+                3 +
+            (ABS(pix[3 * d][1] - pix[d][1]) +
+             ABS(pix[-3 * d][1] - pix[-d][1])) *
+                2;
+      }
+      d = dir[i = diff[0] > diff[1]];
+      pix[0][1] = ULIM(guess[i] >> 2, pix[d][1], pix[-d][1]);
+    }
+  /*  Calculate red and blue for each green pixel:		*/
+  RUN_CALLBACK(LIBRAW_PROGRESS_INTERPOLATE, 1, 3);
+#ifdef LIBRAW_USE_OPENMP
+#pragma omp parallel for default(shared) private(guess, diff, row, col, d, c,  \
+                                                 i, pix) schedule(static)
+#endif
+  for (row = 1; row < height - 1; row++)
+    for (col = 1 + (FC(row, 2) & 1), c = FC(row, col + 1); col < width - 1;
+         col += 2)
+    {
+      pix = image + row * width + col;
+      for (i = 0; i < 2; c = 2 - c, i++)
+      {
+        d = dir[i];
+        pix[0][c] = CLIP(
+            (pix[-d][c] + pix[d][c] + 2 * pix[0][1] - pix[-d][1] - pix[d][1]) >>
+            1);
+      }
+    }
+  /*  Calculate blue for red pixels and vice versa:		*/
+  RUN_CALLBACK(LIBRAW_PROGRESS_INTERPOLATE, 2, 3);
+#ifdef LIBRAW_USE_OPENMP
+#pragma omp parallel for default(shared) private(guess, diff, row, col, d, c,  \
+                                                 i, pix) schedule(static)
+#endif
+  for (row = 1; row < height - 1; row++)
+    for (col = 1 + (FC(row, 1) & 1), c = 2 - FC(row, col); col < width - 1;
+         col += 2)
+    {
+      pix = image + row * width + col;
+      for (i = 0; i < 2; i++)
+      {
+        d = dir[i] + dir[i+1];
+        diff[i] = ABS(pix[-d][c] - pix[d][c]) + ABS(pix[-d][1] - pix[0][1]) +
+                  ABS(pix[d][1] - pix[0][1]);
+        guess[i] =
+            pix[-d][c] + pix[d][c] + 2 * pix[0][1] - pix[-d][1] - pix[d][1];
+      }
+      if (diff[0] != diff[1])
+        pix[0][c] = CLIP(guess[diff[0] > diff[1]] >> 1);
+      else
+        pix[0][c] = CLIP((guess[0] + guess[1]) >> 2);
+    }
+}
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/demosaic/xtrans_demosaic.cpp libkdcraw/libkdcraw/libraw/src/demosaic/xtrans_demosaic.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/demosaic/xtrans_demosaic.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/demosaic/xtrans_demosaic.cpp	2022-11-07 07:46:31.734795008 +0300
@@ -0,0 +1,381 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw uses code from dcraw.c -- Dave Coffin's raw photo decoder,
+ dcraw.c is copyright 1997-2018 by Dave Coffin, dcoffin a cybercom o net.
+ LibRaw do not use RESTRICTED code from dcraw.c
+
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/dcraw_defs.h"
+
+#define fcol(row, col) xtrans[(row + 6) % 6][(col + 6) % 6]
+/*
+   Frank Markesteijn's algorithm for Fuji X-Trans sensors
+ */
+void LibRaw::xtrans_interpolate(int passes)
+{
+  int c, d, f, g, h, i, v, ng, row, col, top, left, mrow, mcol;
+
+  int cstat[4] = {0, 0, 0, 0};
+
+  int val, ndir, pass, hm[8], avg[4], color[3][8];
+  static const short orth[12] = {1, 0, 0, 1, -1, 0, 0, -1, 1, 0, 0, 1},
+                     patt[2][16] = {{0, 1, 0, -1, 2, 0, -1, 0, 1, 1, 1, -1, 0,
+                                     0, 0, 0},
+                                    {0, 1, 0, -2, 1, 0, -2, 0, 1, 1, -2, -2, 1,
+                                     -1, -1, 1}},
+                     dir[4] = {1, LIBRAW_AHD_TILE, LIBRAW_AHD_TILE + 1,
+                               LIBRAW_AHD_TILE - 1};
+  short allhex[3][3][2][8], *hex;
+  ushort min, max, sgrow, sgcol;
+  ushort(*rgb)[LIBRAW_AHD_TILE][LIBRAW_AHD_TILE][3], (*rix)[3], (*pix)[4];
+  short(*lab)[LIBRAW_AHD_TILE][3], (*lix)[3];
+  float(*drv)[LIBRAW_AHD_TILE][LIBRAW_AHD_TILE], diff[6], tr;
+  char(*homo)[LIBRAW_AHD_TILE][LIBRAW_AHD_TILE], *buffer;
+
+  if (width < LIBRAW_AHD_TILE || height < LIBRAW_AHD_TILE)
+    throw LIBRAW_EXCEPTION_IO_CORRUPT; // too small image
+                                       /* Check against right pattern */
+  for (row = 0; row < 6; row++)
+    for (col = 0; col < 6; col++)
+      cstat[(unsigned)fcol(row, col)]++;
+
+  if (cstat[0] < 6 || cstat[0] > 10 || cstat[1] < 16 || cstat[1] > 24 ||
+      cstat[2] < 6 || cstat[2] > 10 || cstat[3])
+    throw LIBRAW_EXCEPTION_IO_CORRUPT;
+
+  // Init allhex table to unreasonable values
+  for (int i = 0; i < 3; i++)
+    for (int j = 0; j < 3; j++)
+      for (int k = 0; k < 2; k++)
+        for (int l = 0; l < 8; l++)
+          allhex[i][j][k][l] = 32700;
+
+  cielab(0, 0);
+  ndir = 4 << (passes > 1);
+  buffer = (char *)malloc(LIBRAW_AHD_TILE * LIBRAW_AHD_TILE * (ndir * 11 + 6));
+  merror(buffer, "xtrans_interpolate()");
+  rgb = (ushort(*)[LIBRAW_AHD_TILE][LIBRAW_AHD_TILE][3])buffer;
+  lab = (short(*)[LIBRAW_AHD_TILE][3])(
+      buffer + LIBRAW_AHD_TILE * LIBRAW_AHD_TILE * (ndir * 6));
+  drv = (float(*)[LIBRAW_AHD_TILE][LIBRAW_AHD_TILE])(
+      buffer + LIBRAW_AHD_TILE * LIBRAW_AHD_TILE * (ndir * 6 + 6));
+  homo = (char(*)[LIBRAW_AHD_TILE][LIBRAW_AHD_TILE])(
+      buffer + LIBRAW_AHD_TILE * LIBRAW_AHD_TILE * (ndir * 10 + 6));
+
+  int minv = 0, maxv = 0, minh = 0, maxh = 0;
+  /* Map a green hexagon around each non-green pixel and vice versa:	*/
+  for (row = 0; row < 3; row++)
+    for (col = 0; col < 3; col++)
+      for (ng = d = 0; d < 10; d += 2)
+      {
+        g = fcol(row, col) == 1;
+        if (fcol(row + orth[d], col + orth[d + 2]) == 1)
+          ng = 0;
+        else
+          ng++;
+        if (ng == 4)
+        {
+          sgrow = row;
+          sgcol = col;
+        }
+        if (ng == g + 1)
+          FORC(8)
+          {
+            v = orth[d] * patt[g][c * 2] + orth[d + 1] * patt[g][c * 2 + 1];
+            h = orth[d + 2] * patt[g][c * 2] + orth[d + 3] * patt[g][c * 2 + 1];
+            minv = MIN(v, minv);
+            maxv = MAX(v, maxv);
+            minh = MIN(v, minh);
+            maxh = MAX(v, maxh);
+            allhex[row][col][0][c ^ (g * 2 & d)] = h + v * width;
+            allhex[row][col][1][c ^ (g * 2 & d)] = h + v * LIBRAW_AHD_TILE;
+          }
+      }
+
+  // Check allhex table initialization
+  for (int i = 0; i < 3; i++)
+    for (int j = 0; j < 3; j++)
+      for (int k = 0; k < 2; k++)
+        for (int l = 0; l < 8; l++)
+          if (allhex[i][j][k][l] > maxh + maxv * width + 1 ||
+              allhex[i][j][k][l] < minh + minv * width - 1)
+            throw LIBRAW_EXCEPTION_IO_CORRUPT;
+  int retrycount = 0;
+
+  /* Set green1 and green3 to the minimum and maximum allowed values:	*/
+  for (row = 2; row < height - 2; row++)
+    for (min = ~(max = 0), col = 2; col < width - 2; col++)
+    {
+      if (fcol(row, col) == 1 && (min = ~(max = 0)))
+        continue;
+      pix = image + row * width + col;
+      hex = allhex[row % 3][col % 3][0];
+      if (!max)
+        FORC(6)
+        {
+          val = pix[hex[c]][1];
+          if (min > val)
+            min = val;
+          if (max < val)
+            max = val;
+        }
+      pix[0][1] = min;
+      pix[0][3] = max;
+      switch ((row - sgrow) % 3)
+      {
+      case 1:
+        if (row < height - 3)
+        {
+          row++;
+          col--;
+        }
+        break;
+      case 2:
+        if ((min = ~(max = 0)) && (col += 2) < width - 3 && row > 2)
+        {
+          row--;
+          if (retrycount++ > width * height)
+            throw LIBRAW_EXCEPTION_IO_CORRUPT;
+        }
+      }
+    }
+
+  for (row = 3; row < 9 && row < height - 3; row++)
+	  for (col = 3; col < 9 && col < width - 3; col++)
+	  {
+		  if ((f = fcol(row, col)) == 1)
+			  continue;
+		  hex = allhex[row % 3][col % 3][0];
+		  FORC(2)
+		  {
+			  int idx3 = 3 * hex[4 + c] + row * width + col;
+			  int idx4 = -3 * hex[4 + c] + row * width + col;
+			  int maxidx = width * height;
+			  if (idx3 < 0 || idx3 >= maxidx)
+				  throw LIBRAW_EXCEPTION_IO_CORRUPT;
+			  if (idx4 < 0 || idx4 >= maxidx)
+				  throw LIBRAW_EXCEPTION_IO_CORRUPT;
+		  }
+	  }
+
+  for (top = 3; top < height - 19; top += LIBRAW_AHD_TILE - 16)
+    for (left = 3; left < width - 19; left += LIBRAW_AHD_TILE - 16)
+    {
+      mrow = MIN(top + LIBRAW_AHD_TILE, height - 3);
+      mcol = MIN(left + LIBRAW_AHD_TILE, width - 3);
+      for (row = top; row < mrow; row++)
+        for (col = left; col < mcol; col++)
+          memcpy(rgb[0][row - top][col - left], image[row * width + col], 6);
+      FORC3 memcpy(rgb[c + 1], rgb[0], sizeof *rgb);
+
+      /* Interpolate green horizontally, vertically, and along both diagonals:
+       */
+      for (row = top; row < mrow; row++)
+        for (col = left; col < mcol; col++)
+        {
+          if ((f = fcol(row, col)) == 1)
+            continue;
+          pix = image + row * width + col;
+          hex = allhex[row % 3][col % 3][0];
+          color[1][0] = 174 * (pix[hex[1]][1] + pix[hex[0]][1]) -
+                        46 * (pix[2 * hex[1]][1] + pix[2 * hex[0]][1]);
+          color[1][1] = 223 * pix[hex[3]][1] + pix[hex[2]][1] * 33 +
+                        92 * (pix[0][f] - pix[-hex[2]][f]);
+          FORC(2)
+          color[1][2 + c] = 164 * pix[hex[4 + c]][1] +
+                            92 * pix[-2 * hex[4 + c]][1] +
+                            33 * (2 * pix[0][f] - pix[3 * hex[4 + c]][f] -
+                                  pix[-3 * hex[4 + c]][f]);
+          FORC4 rgb[c ^ !((row - sgrow) % 3)][row - top][col - left][1] =
+              LIM(color[1][c] >> 8, pix[0][1], pix[0][3]);
+        }
+
+      for (pass = 0; pass < passes; pass++)
+      {
+        if (pass == 1)
+          memcpy(rgb += 4, buffer, 4 * sizeof *rgb);
+
+        /* Recalculate green from interpolated values of closer pixels:	*/
+        if (pass)
+        {
+          for (row = top + 2; row < mrow - 2; row++)
+            for (col = left + 2; col < mcol - 2; col++)
+            {
+              if ((f = fcol(row, col)) == 1)
+                continue;
+              pix = image + row * width + col;
+              hex = allhex[row % 3][col % 3][1];
+              for (d = 3; d < 6; d++)
+              {
+                rix =
+                    &rgb[(d - 2) ^ !((row - sgrow) % 3)][row - top][col - left];
+                val = rix[-2 * hex[d]][1] + 2 * rix[hex[d]][1] -
+                      rix[-2 * hex[d]][f] - 2 * rix[hex[d]][f] + 3 * rix[0][f];
+                rix[0][1] = LIM(val / 3, pix[0][1], pix[0][3]);
+              }
+            }
+        }
+
+        /* Interpolate red and blue values for solitary green pixels:	*/
+        for (row = (top - sgrow + 4) / 3 * 3 + sgrow; row < mrow - 2; row += 3)
+          for (col = (left - sgcol + 4) / 3 * 3 + sgcol; col < mcol - 2;
+               col += 3)
+          {
+            rix = &rgb[0][row - top][col - left];
+            h = fcol(row, col + 1);
+            memset(diff, 0, sizeof diff);
+            for (i = 1, d = 0; d < 6; d++, i ^= LIBRAW_AHD_TILE ^ 1, h ^= 2)
+            {
+              for (c = 0; c < 2; c++, h ^= 2)
+              {
+                g = 2 * rix[0][1] - rix[i << c][1] - rix[-i << c][1];
+                color[h][d] = g + rix[i << c][h] + rix[-i << c][h];
+                if (d > 1)
+                  diff[d] += SQR((float)rix[i << c][1] - (float)rix[-i << c][1] -
+                  (float)rix[i << c][h] + (float)rix[-i << c][h]) + SQR((float)g);
+              }
+              if (d > 1 && (d & 1))
+                if (diff[d - 1] < diff[d])
+                  FORC(2) color[c * 2][d] = color[c * 2][d - 1];
+              if (d < 2 || (d & 1))
+              {
+                FORC(2) rix[0][c * 2] = CLIP(color[c * 2][d] / 2);
+                rix += LIBRAW_AHD_TILE * LIBRAW_AHD_TILE;
+              }
+            }
+          }
+
+        /* Interpolate red for blue pixels and vice versa:		*/
+        for (row = top + 3; row < mrow - 3; row++)
+          for (col = left + 3; col < mcol - 3; col++)
+          {
+            if ((f = 2 - fcol(row, col)) == 1)
+              continue;
+            rix = &rgb[0][row - top][col - left];
+            c = (row - sgrow) % 3 ? LIBRAW_AHD_TILE : 1;
+            h = 3 * (c ^ LIBRAW_AHD_TILE ^ 1);
+            for (d = 0; d < 4; d++, rix += LIBRAW_AHD_TILE * LIBRAW_AHD_TILE)
+            {
+              i = d > 1 || ((d ^ c) & 1) ||
+                          ((ABS(rix[0][1] - rix[c][1]) +
+                            ABS(rix[0][1] - rix[-c][1])) <
+                           2 * (ABS(rix[0][1] - rix[h][1]) +
+                                ABS(rix[0][1] - rix[-h][1])))
+                      ? c
+                      : h;
+              rix[0][f] = CLIP((rix[i][f] + rix[-i][f] + 2 * rix[0][1] -
+                                rix[i][1] - rix[-i][1]) /
+                               2);
+            }
+          }
+
+        /* Fill in red and blue for 2x2 blocks of green:		*/
+        for (row = top + 2; row < mrow - 2; row++)
+          if ((row - sgrow) % 3)
+            for (col = left + 2; col < mcol - 2; col++)
+              if ((col - sgcol) % 3)
+              {
+                rix = &rgb[0][row - top][col - left];
+                hex = allhex[row % 3][col % 3][1];
+                for (d = 0; d < ndir;
+                     d += 2, rix += LIBRAW_AHD_TILE * LIBRAW_AHD_TILE)
+                  if (hex[d] + hex[d + 1])
+                  {
+                    g = 3 * rix[0][1] - 2 * rix[hex[d]][1] - rix[hex[d + 1]][1];
+                    for (c = 0; c < 4; c += 2)
+                      rix[0][c] = CLIP(
+                          (g + 2 * rix[hex[d]][c] + rix[hex[d + 1]][c]) / 3);
+                  }
+                  else
+                  {
+                    g = 2 * rix[0][1] - rix[hex[d]][1] - rix[hex[d + 1]][1];
+                    for (c = 0; c < 4; c += 2)
+                      rix[0][c] =
+                          CLIP((g + rix[hex[d]][c] + rix[hex[d + 1]][c]) / 2);
+                  }
+              }
+      }
+      rgb = (ushort(*)[LIBRAW_AHD_TILE][LIBRAW_AHD_TILE][3])buffer;
+      mrow -= top;
+      mcol -= left;
+
+      /* Convert to CIELab and differentiate in all directions:	*/
+      for (d = 0; d < ndir; d++)
+      {
+        for (row = 2; row < mrow - 2; row++)
+          for (col = 2; col < mcol - 2; col++)
+            cielab(rgb[d][row][col], lab[row][col]);
+        for (f = dir[d & 3], row = 3; row < mrow - 3; row++)
+          for (col = 3; col < mcol - 3; col++)
+          {
+            lix = &lab[row][col];
+            g = 2 * lix[0][0] - lix[f][0] - lix[-f][0];
+            drv[d][row][col] =
+                SQR(g) +
+                SQR((2 * lix[0][1] - lix[f][1] - lix[-f][1] + g * 500 / 232)) +
+                SQR((2 * lix[0][2] - lix[f][2] - lix[-f][2] - g * 500 / 580));
+          }
+      }
+
+      /* Build homogeneity maps from the derivatives:			*/
+      memset(homo, 0, ndir * LIBRAW_AHD_TILE * LIBRAW_AHD_TILE);
+      for (row = 4; row < mrow - 4; row++)
+        for (col = 4; col < mcol - 4; col++)
+        {
+          for (tr = FLT_MAX, d = 0; d < ndir; d++)
+            if (tr > drv[d][row][col])
+              tr = drv[d][row][col];
+          tr *= 8;
+          for (d = 0; d < ndir; d++)
+            for (v = -1; v <= 1; v++)
+              for (h = -1; h <= 1; h++)
+                if (drv[d][row + v][col + h] <= tr)
+                  homo[d][row][col]++;
+        }
+
+      /* Average the most homogenous pixels for the final result:	*/
+      if (height - top < LIBRAW_AHD_TILE + 4)
+        mrow = height - top + 2;
+      if (width - left < LIBRAW_AHD_TILE + 4)
+        mcol = width - left + 2;
+      for (row = MIN(top, 8); row < mrow - 8; row++)
+        for (col = MIN(left, 8); col < mcol - 8; col++)
+        {
+          for (d = 0; d < ndir; d++)
+            for (hm[d] = 0, v = -2; v <= 2; v++)
+              for (h = -2; h <= 2; h++)
+                hm[d] += homo[d][row + v][col + h];
+          for (d = 0; d < ndir - 4; d++)
+            if (hm[d] < hm[d + 4])
+              hm[d] = 0;
+            else if (hm[d] > hm[d + 4])
+              hm[d + 4] = 0;
+          for (max = hm[0], d = 1; d < ndir; d++)
+            if (max < hm[d])
+              max = hm[d];
+          max -= max >> 3;
+          memset(avg, 0, sizeof avg);
+          for (d = 0; d < ndir; d++)
+            if (hm[d] >= max)
+            {
+              FORC3 avg[c] += rgb[d][row][col][c];
+              avg[3]++;
+            }
+          FORC3 image[(row + top) * width + col + left][c] = avg[c] / avg[3];
+        }
+    }
+  free(buffer);
+  border_interpolate(8);
+}
+#undef fcol
